# Misc library module,
# Rick Smereka, Copyright (C) 2005.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, get a copy via the Internet at
# http://gnu.org/copyleft/gpl.html or write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307 USA

# You can contact the author via email at rsmereka@future-lab.com

# Initial tcl version Mar/2005, Rick Smereka

proc rnd {lowr highr} {
   # Generate a random number in the range 'lowr' to 'highr'
   # (inclusive). Returns the random number upon
   # success, '-1' otherwise.
   set mname "rnd"

   if {$lowr >= $highr} {
      logman "$mname:range(lowr must be less than highr)"
      return -1
   }

   if {$lowr == 0} {
      set nhighr [expr $highr + 1]
      set result [expr int([expr rand() * $nhighr])]
   } else {
      set range [expr $highr - $lowr + 1]
      set result [expr int([expr rand() * $range]) + $lowr]
   }

   return $result
   #set maxf [expr [expr $highr + 1] - $lowr]
   #set value [expr int([expr rand() * $highr])]
   #set value [expr [expr $value % $maxf] + $lowr]
   #return $value
}
